
// strnstr.cpp

// implements the strnstr function, searching for one string within another, with a limit

#include "stdafx.h"
#include <stdio.h>
#include <string.h>





const char * strnstr(const char * iString, const char * iPattern, size_t str1limit)
{
	size_t len2 = strlen(iPattern);
	if (len2 == 0)
	{
		return iString;
	}
	str1limit -= len2;
	for (size_t i = 0; i <= str1limit; i++)
	{
		if (iString[i] == 0)
		{
			return NULL;		// not found, end of string
		}
		else if (iString[i] == iPattern[0])
		{
			if (memcmp(iString + i, iPattern, len2) == 0)
			{
				return iString + i;		// found
			}
		}
	}		// for i
	return NULL;
}




